﻿using UnityEngine;
using System.Collections;
using GameTools;
public class ScreenShot
{
	public ScreenShot ()
	{

	}
	/// <summary>
	/// Returns a filename with the date and time preprended to the string passed in
	/// </summary>
	/// <returns>
	/// The date nice file name.
	/// </returns>
	public static string GetDateNiceFileName(string basestr)
	{
		string datename = System.DateTime.Now.ToString("yyyy_dd_MM_H_mm_ss") + basestr;
		return datename;
	}
	

	public static string BuildSafeFilename(string orig)
	{
		string fileName = orig;
		fileName = fileName.Replace (" ", "_");
		foreach (char c in System.IO.Path.GetInvalidFileNameChars())
		{
			fileName = fileName.Replace(c, '_');
		}
		return fileName;
	}

	public static IEnumerator UploadPNG (string user_name, string game, int maxfiles) {
		
		// We should only read the screen buffer after rendering is complete
		//yield return StartCoroutine(WaitForEndOfFrame());
		// Create a texture the size of the screen, RGB24 format
		var width = Screen.width;
		var height = Screen.height;
		var tex = new Texture2D (width, height, TextureFormat.RGB24, false);
		// Read screen contents into the texture
		tex.ReadPixels (new Rect(0, 0, width, height), 0, 0);
		tex.Apply ();
		// Encode texture into PNG
		var bytes = tex.EncodeToPNG();
		GameObject.Destroy (tex);
		
		// Create a Web Form
		var form = new WWWForm();
		form.AddField("username", user_name);

		form.AddField("game", game);
		if (maxfiles == 0) maxfiles = 1;
		form.AddField("maxfiles", maxfiles);
		form.AddBinaryData("file", bytes,GetDateNiceFileName(game+".png"), "image/png");

		// Upload to a cgi script
		
		//WWW w = new WWW("http:/localhostcgi-bin/env.cgi?post", form);
		WWW w = new WWW("http://blog.brentknowles.com/unity/screener.php", form);
		
		yield return w;
		if (w.error != null) {
			simplelog.Instance.Line("uploadpng", simplelog.ProblemType.ERROR,w.error);
		} else {
				simplelog.Instance.Line("uploadpng", simplelog.ProblemType.MESSAGE,"Finished Uploading Screenshot");
						
		}
		yield break;
	}
}
