﻿using UnityEngine;
using System.Collections;

public class sceneguiexample : MonoBehaviour {
	
	public bool Show1SimpleLabel = true;
	public bool Show2GuiLayout = false;
	public bool Show3ButtonResponseMenu = false;
	public bool Show4ButtonImage = false;
	public bool Show5ButtonImageAndText = false;
	public bool Show6ButtonImageBelowText = false;
	public bool Show9Mouseover = false;
	public bool Show10GUIStyle=false;
	public bool Show11GuiSkin = false;
	public bool Show12DisabledButton = false;
	public bool Show13Toggle = false;
	public bool Show14AskName = false;
	public bool Show15GUIFormat = false;
	public bool Show16Scrolling=false;
	
	public bool Show20LoaderLevel = false;
	
	
	
	
	public Texture buttonTexture;
	public Texture buttonMouseOverTexture;
	public GUIStyle superStyle1;
	public GUISkin overrideSkin = null;
	
	
	void OnGUI () {
	
		// we use a skin only if we have selected the appropriate option and there is an override skin to use.
		if (Show11GuiSkin && overrideSkin != null)
		{
			// if we have provided an alternate skin, we use it.
			GUI.skin = overrideSkin;
		}
		
		if (Show1SimpleLabel)
		{
			GUI.Label(new Rect(20,20,100,90), "Hello, eh.");
		}
	
		if (Show2GuiLayout)
		{
			ShowGuiLayoutExample();
		}
		if (Show3ButtonResponseMenu)
		{
			ShowButtonResponseMenuExample();
		}
		if (Show4ButtonImage)
		{
			ShowButtonWithImage();
		}
		if (Show5ButtonImageAndText)
		{
			ShowButtonWithImageAndText();
		}
		if (Show6ButtonImageBelowText)
		{
			ShowButtonImageBelowText();
		}
		if (Show9Mouseover)
		{
			ShowMouseOver();
		}
		if (Show10GUIStyle)
		{
			ShowGUIStyle();
		}
		if (Show12DisabledButton)
		{
			ShowDisabled();
		}
		if (Show13Toggle)
		{
			BuildToggleButton("Button 1");
			BuildToggleButton("Button 2");
			BuildToggleButton("Button 3");
		}
		if (Show14AskName)
		{
			ShowAskName();
		}
		if (Show15GUIFormat)
		{
			ShowGUIFormat();
		}
		if (Show16Scrolling)
		{
			ShowScrolling();
		}
		
		if (Show20LoaderLevel)
		{
				ShowLoaderLevel();
		}
	}
	
	Vector2 scrollPosition;
	private void ShowScrolling()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		
		
		GUILayout.Button ("Button above scrolling area");
		scrollPosition = GUILayout.BeginScrollView(scrollPosition, GUILayout.Width (200), GUILayout.Height (100));
	
		string texttouse = "This a line!\nFollowed by another.\nAnd another.\nYou won't find anything interesting here.\nThis a line!\nFollowed by another.\nAnd another.\nYou won't find anything interesting here.";
		GUILayout.TextField(texttouse);
		GUILayout.Button ("Button within scrolling area");
		GUILayout.EndScrollView();
		GUILayout.Button ("Button below scrolling area");
		
		
		GUILayout.EndArea();
	}
	private void ShowGUIFormat()
	{
		GUIStyle labelStyle  =  GUI.skin.GetStyle("fancylabel");
		GUILayout.BeginArea(new Rect(400,5,500,300));
		GUILayout.BeginHorizontal();
		
		string sampletext = "Be <b>bold</b> when necessary! Or if you prefer <i>italics</i>, they are available too\n. Or be <color=green>col</color><color=red>orf</color><color=blue>ull</color>. But <size=50>avoid</size> crazy size changes.";
		GUILayout.Label(sampletext, labelStyle);
		
		
		GUILayout.EndHorizontal();
		GUILayout.EndArea();
	}
	
	
	private string myText="Default text\nNext line";
	private void ShowAskName()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		
		myText = GUILayout.TextField(myText);
		Debug.Log (myText);
		
		GUILayout.EndHorizontal();
		GUILayout.EndArea();
	}
	
	
	
	GUIStyle categoryStyle;
	string currentTogglebutton = "";
	private void BuildToggleButton(string ButtonToBuild)
	{
		// Create a category style programmatically (instead of assigning it via the GUI)
		if (null == categoryStyle)
		{
			categoryStyle = new GUIStyle (GUI.skin.button);
			categoryStyle.normal.textColor = Color.green;
			categoryStyle.hover.textColor = Color.green;
		}
		
		// by default use the default style
		GUIStyle styletouse = GUI.skin.button;
		if (ButtonToBuild == currentTogglebutton)
		{
			styletouse = categoryStyle;
		}
		
		if (GUILayout.Button (ButtonToBuild, styletouse)) {
			currentTogglebutton = ButtonToBuild;
		}
	}

	private void ShowDisabled()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		if (GUILayout.Button("Torso"))
		{
		}
		GUI.enabled = false;
		if (GUILayout.Button("Head"))
		{
		}
		GUI.enabled = true;
		if (GUILayout.Button("Feet"))
		{
		}
		GUILayout.EndHorizontal();
	GUILayout.EndArea();
	}
	private void ShowGUIStyle()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		if (GUILayout.Button("Torso", superStyle1))
		{
		}
		if (GUILayout.Button("Head", superStyle1))
		{
		}
		GUILayout.EndHorizontal();
	GUILayout.EndArea();
	}
	private void ShowMouseOver()
	{
			GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		
		if (buttonTexture != null && buttonMouseOverTexture != null)
		{
			if (GUILayout.Button(buttonTexture))
			{
				
			}
			Rect r = GUILayoutUtility.GetLastRect(); //Get the Rect of the previous GUILayout element
			// now build a new rectangle where we modify the Y coordinate so that the image will be drawn lower
			if (r.Contains(Event.current.mousePosition))
			{
				GUI.DrawTexture(new Rect(r.left, r.top, r.width, r.height), buttonMouseOverTexture,ScaleMode.ScaleToFit,true);
			}

		}
		else
		{
			GUILayout.Label ("You did not specify a button image to use.");
		}
		
		GUILayout.EndHorizontal();
		GUILayout.EndArea();
	}
	// Uses GetLastRect to move image below
	private void ShowButtonImageBelowText()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		
		if (buttonTexture != null)
		{
			if (GUILayout.Button("Howdy Button"))
			{
				
			}
			Rect r = GUILayoutUtility.GetLastRect(); //Get the Rect of the previous GUILayout element
			// now build a new rectangle where we modify the Y coordinate so that the image will be drawn lower
			Rect newRect = new Rect(r.x, r.y + 25, 25, r.height);
			// Note: We also adjusted the width, else the texture would have been stretched to fit the button's width
			GUI.DrawTexture(newRect, buttonTexture);
		}
		else
		{
			GUILayout.Label ("You did not specify a button image to use.");
		}
		
		GUILayout.EndHorizontal();
		GUILayout.EndArea();
	}
	private void ShowGuiLayoutExample()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		if (GUILayout.Button("Torso"))
		{
		}
		if (GUILayout.Button("Head"))
		{
		}
		GUILayout.EndHorizontal();
		GUILayout.Button ("Head1");
		GUILayout.Button ("Head2");
	GUILayout.EndArea();
	}
	
	private void ShowButtonWithImage()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		
		if (buttonTexture != null)
		{
			if (GUILayout.Button(buttonTexture))
			{
				
			}
		}
		else
		{
			GUILayout.Label ("You did not specify a button image to use.");
		}
		
		GUILayout.EndHorizontal();
		GUILayout.EndArea();
	}
	
	private void ShowButtonWithImageAndText()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		
		if (buttonTexture != null)
		{
			GUIContent content = new GUIContent("My Button", buttonTexture);
			if (GUILayout.Button(content))
			{
				
			}
		}
		else
		{
			GUILayout.Label ("You did not specify a button image to use.");
		}
		
		GUILayout.EndHorizontal();
		GUILayout.EndArea();
	}
	
	
	int menumode = 0;
	private void ShowButtonResponseMenuExample()
	{
		GUILayout.BeginArea(new Rect(400,5,300,300));
		GUILayout.BeginHorizontal();
		if (GUILayout.Button("Torso"))
		{
			menumode = 1;
		}
		if (GUILayout.Button("Head"))
		{
			menumode = 2;
		}
		GUILayout.EndHorizontal();
		if (menumode == 1)
		{
			GUILayout.Button ("Torso1");
			GUILayout.Button ("Torso2");
			GUILayout.Button ("Torso3");
		}
		if (menumode == 2)
		{
			GUILayout.Button ("Head1");
			GUILayout.Button ("Head2");
		}
		GUILayout.EndArea();
	}
	private void ShowLoaderLevel()
	{
		// Make a background box
		GUI.Box(new Rect(10,10,100,90), "Loader Menu");

		// Make the first button. If it is pressed, Application.Loadlevel (1) will be executed
		if(GUI.Button(new Rect(20,40,80,20), "Level 1")) {
			Application.LoadLevel(1);
		}

		// Make the second button.
		if(GUI.Button(new Rect(20,70,80,20), "Level 2")) {
			Application.LoadLevel(2);
		}
	}

}
