﻿using UnityEngine;
using System.Collections;

namespace GameTools
{
	public static class Pause
	{


		/// <summary>
		/// Pause/unpause helper.
		/// 
		/// Calling function responsiblity for tracking pause state
		/// </summary>
		/// <param name='On'>
		/// If set to <c>true</c> on.
		/// </param>
		public static void DoPause(bool On)
		{
			GameObject[] objects  = (GameObject[])GameObject.FindObjectsOfType (typeof(GameObject));
			if (false == On)
			{
				Time.timeScale=1;
				simplelog.Instance.Line("DoPause", simplelog.ProblemType.MESSAGE, "unpause");
				foreach (var go in objects) {
					go.SendMessage ("OnResumeGame", SendMessageOptions.DontRequireReceiver);
				}

			}
			else
			{
				Time.timeScale=0;
				simplelog.Instance.Line("DoPause", simplelog.ProblemType.MESSAGE, "pause");
				foreach (var go in objects) {
					go.SendMessage ("OnPauseGame", SendMessageOptions.DontRequireReceiver);
				}
			}
		}
	}
}

