﻿using UnityEngine;
using System.Collections;

public class basicmove : MonoBehaviour {
/// This script moves the character controller forward 
	/// and sideways based on the arrow keys.
	/// It also jumps when pressing space.
	/// Make sure to attach a character controller to the same game object.
	/// It is recommended that you make only one call to Move or SimpleMove per frame.	
	public float speed = 6.0f;
	public float jumpSpeed = 8.0f;
	float jumpModifier = 0.0f;
	Color originalColor;
	public float  gravity = 20.0f;
	private Vector3 moveDirection = (Vector3.zero);
	public bool AllowSuperJumpMode = false;
	void Start()
	{
		originalColor = Color.green;
		this.renderer.material.color = originalColor;
	}
	void Update() {
		CharacterController controller  = (CharacterController)GetComponent(typeof(CharacterController));
		if (controller.isGrounded) {
			// We are grounded, so recalculate
			// move direction directly from axes
			moveDirection = new Vector3(Input.GetAxis("Horizontal"), 0,
			                        Input.GetAxis("Vertical"));
			moveDirection = transform.TransformDirection(moveDirection);
			moveDirection *= speed;
			
			if (Input.GetButton ("Jump")) {
				moveDirection.y = (jumpSpeed+jumpModifier);
			}
		}
		
		if (AllowSuperJumpMode)
		{
		if (Input.GetButton ("Fire1"))
		{
			if (jumpModifier == 0.0f)
			{
				originalColor = this.renderer.material.color;
				this.renderer.material.color = Color.blue;
				jumpModifier = 10.0f;
			}
			else
			{
				this.renderer.material.color = originalColor;
				jumpModifier = 0.0f;
			}
		}
		}
		
		// Apply gravity
		moveDirection.y -= gravity * Time.deltaTime;
		
		// Move the controller
		controller.Move(moveDirection * Time.deltaTime);
	}
	
	
	// * This code will be used in a later tutorial on instantiating prefabs
	
	bool spawnonce = false;
	void OnControllerColliderHit(ControllerColliderHit objectHit){
		if (objectHit.gameObject.tag == "spawner")
		{
			if (false == spawnonce)
			{
				spawnonce = true;
				// Send Message to target to spawn
				objectHit.gameObject.SendMessage("instant", 2);
				Debug.Log ("spawn");
			}
			
		}
		
	}
}
