﻿using UnityEngine;
using System.Collections;
using System;

namespace GameTools
{
public class simplelog : IDisposable
{
		protected static volatile simplelog instance;
		protected static object syncRoot = new System.Object();
	
		// defaulting to true on this while doing unity build work
		public bool OutputToConstoleToo=true;
	
		// each logged message we output has a "loudness" rating. We could write code to filter by loudness.
		public enum Loud {ACRITICAL=0, BDEFAULT=1,CTRIVIAL=2, DOFF=3};
		private Loud _Loudness = Loud.BDEFAULT;// We show default and louder but not Trivial
		public Loud Loudness { get { return _Loudness; } set { _Loudness = value; }}

		// a qualifier on each logged message to give an indication of its intent
		public enum ProblemType {MESSAGE, ERROR, TEMPORARY,EXCEPTION, WARNING, TIMING};
	
		// this is the important method -- it creates the instance
		// and allows only once instance to ever be retrieved
		public static simplelog Instance
		{
				get
				{
					if (null == instance)
					{
						// only one instance is created and when needed
						lock (syncRoot)
						{
							if (null == instance)
							{
						}
								instance = new simplelog();
							}
						}
					
					return (simplelog)instance;
				}
		}
			
		public void Line(string Routine, ProblemType Problem, string Details)
		{
			Line(Routine, Problem, Details, Loud.ACRITICAL);
		}
	
		// if this method is assigned by the developer
		// to another routine, we can redirect the Unity logging to another location
		public Action<string> ConsoleWriter = null;
		// this allows us to override the console writing behavior
		// useful for unity
		void ConsoleIt (string log)
		{
			if (ConsoleWriter == null) {
				///Console.WriteLine (log);
				Debug.Log (log);
			} else {
				ConsoleWriter(log);
			}
		}
	
		
		public void Line (string Routine, ProblemType Problem, string Details, Loud myLoudness)
		{
			bool show = true;
			if ((this.Loudness == Loud.DOFF) || (this.Loudness < myLoudness)) {
				show = false;
			} 
			if (true == show)
			{
				string log = (String.Format ("{0}, {1}, {2}, {3}", Routine, Problem.ToString (), Details, myLoudness));
				if (OutputToConstoleToo)
				{
					ConsoleIt (log);
				}
				
			}
		
			// for non Unity projects I might have code stub here to write to a database or something
		}
		public void Dispose()
		{
			// if you were writing directly to a file or database you might
			// use this method to output any log buffer to that location 
			// upon disposal
		}
}

}